import 'package:flutter/material.dart';
import 'package:sql_query/query.dart';
import 'package:sql_query/viewer/controller/query_controller.dart';
import 'package:sql_query/viewer/part/button.dart';

import '../model/auto_model.dart';
import '../model/sql_master_model.dart';
import '../part/base_widget.dart';
import '../part/form.dart';
import '../part/main_view.dart';
import '../part/select.dart';

class SQL {
  static List<SelectData> selectColumn = [];
  static SQLMasterModel? selectedTable;
  static List<TableDatabase> listTableDatabase = [];
  static ForeignKey? currentForeignKey;
  static List<ForeignKey> listOtherRelation = [];
  static DBMerge? _dataMerge;
  static TableDatabase? globalData;
  static Fresh<bool> loading = Fresh(true);
  static Fresh<int> menuActive = Fresh(0);
  static Fresh<List<SQLMasterModel>> dataTable = Fresh([]);
  static List<Widget> buildTableRow = [];
  static List showedData = [];
  static int? maxData;

  static selectTable(SQLMasterModel table, {Function? fillFunction}) async {
    loading.refresh((listener) => listener.value = true);
    QueryController.clear();
    listOtherRelation = [];
    maxData = 0;
    currentForeignKey = null;
    globalData = null;
    dataTable.refresh((listener) => selectedTable = table);
    if (fillFunction != null) {
      fillFunction();
    }
    if (menuActive.value == 1) {
      getTableRow();
    } else if (menuActive.value == 2) {
      getRelation();
    } else {
      loading.refresh((listener) => listener.value = false);
    }
    // print(await DB.table(selectedTable?.tableName ?? '').get());
  }

  static getRelation({Function? withFunction}) async {
    currentForeignKey = null;
    loading.refresh((listener) => listener.value = true);
    await replacedFunction(
      StackFunction(
        id: 2,
        function: () async {
          listOtherRelation = [];
          final getDataForeign = await DB.table('_sql_query_foreign_key').where('name_table', '=', selectedTable?.tableName).get();
          for (var i in getDataForeign) {
            currentForeignKey = ForeignKey(
              baseColumn: i['name_column'],
              referenceTable: i['name_table_target'],
              referenceColumn: i['name_column_target'],
              deleteAction: ForeignKey.parseAction(i['on_delete']),
              updateAction: ForeignKey.parseAction(i['on_update']),
            );
          }
          final getDataOtherForeign = await DB.table('_sql_query_foreign_key').where('name_table_target', '=', selectedTable!.tableName).get();
          for (var i in getDataOtherForeign) {
            listOtherRelation.add(ForeignKey(
              baseColumn: i['name_column'],
              referenceTable: i['name_table_target'],
              baseTable: i['name_table'],
              referenceColumn: i['name_column_target'],
              deleteAction: ForeignKey.parseAction(i['on_delete']),
              updateAction: ForeignKey.parseAction(i['on_update']),
            ));
          }
          dataTable.refresh((listener) => null);
          if (withFunction != null) {
            withFunction();
          }
          loading.refresh((listener) => listener.value = false);
        },
      ),
    );
  }

  static getTableRow() async {
    loading.refresh((listener) => listener.value = true);
    replacedFunction(
      StackFunction(
        id: 1,
        function: () async {
          await getRelation(withFunction: () async {
            buildTableRow = [];
            showedData = [];
            selectColumn = [];
            final getDataColumn = SQL.listTableDatabase.where((element) => element.tableName == SQL.selectedTable?.tableName);

            TableDatabase? data;
            if (getDataColumn.isNotEmpty) {
              data = getDataColumn.first;
              globalData = data;
            }
            if (data != null) {
              final getQ = _dataMerge != null ? _dataMerge!.table(data.tableName).limit(double.parse(QueryController.limit.controller?.text ?? '50').floor()) : DB.table(data.tableName).limit(double.parse(QueryController.limit.controller?.text ?? '50').floor());
              try {
                if (QueryController.selectedFilterColumn != null) {
                  getQ.where(QueryController.selectedFilterColumn?.id, 'LIKE', '%${QueryController.search.controller!.text}%');
                }
              } catch (_) {}
              final getData = await getQ.get();
              maxData = getData.length;
              for (var i in data.column) {
                selectColumn.add(
                  SelectData(
                    id: i.name,
                    title: i.name,
                  ),
                );
                if (i.primaryKey) {
                  for (var j in getData) {
                    showedData.add(j[i.name]);
                  }
                }
                final List<Widget> buildTableRowIn = [];
                buildTableRowIn.add(
                  Padding(
                    padding: const EdgeInsets.only(bottom: 8.0),
                    child: Container(
                      padding: const EdgeInsets.symmetric(horizontal: 20, vertical: 12),
                      decoration: BoxDecoration(
                        color: const Color(0xffF8F8F8),
                        borderRadius: BorderRadius.circular(7),
                        border: Border.all(color: (currentForeignKey?.baseColumn != null && currentForeignKey?.baseColumn == i.name) ? Colors.green : Colors.black26, width: 1),
                      ),
                      child: Row(
                        children: [
                          Expanded(child: Text(i.name)),
                        ],
                      ),
                    ),
                  ),
                );
                for (var j in getData) {
                  final ref = currentForeignKey?.referenceColumn;
                  buildTableRowIn.add(
                    Padding(
                      padding: const EdgeInsets.only(bottom: 8.0),
                      child: GestureDetector(
                        onTap: () {
                          // print((currentForeignKey?.baseColumn != null && currentForeignKey?.baseColumn == i.name));
                          if ((currentForeignKey?.baseColumn != null && currentForeignKey?.baseColumn == i.name)) {
                            selectTable(dataTable.value.where((element) => element.tableName == currentForeignKey!.referenceTable).first, fillFunction: () {
                              QueryController.selectedFilterColumn = SelectData(
                                id: ref,
                                title: ref,
                              );
                              QueryController.search.controller!.text = j[i.name].toString();
                            });
                          }
                        },
                        child: Container(
                          padding: const EdgeInsets.symmetric(horizontal: 20, vertical: 12),
                          decoration: BoxDecoration(
                            color: const Color(0xffF8F8F8),
                            borderRadius: BorderRadius.circular(7),
                            border: Border.all(color: (currentForeignKey?.baseColumn != null && currentForeignKey?.baseColumn == i.name) ? Colors.green : Colors.black26, width: 1),
                          ),
                          child: Row(
                            children: [
                              Expanded(
                                child: Text(
                                  j[i.name].toString(),
                                ),
                              ),
                            ],
                          ),
                        ),
                      ),
                    ),
                  );
                }

                buildTableRow.add(
                  Padding(
                    padding: const EdgeInsets.only(right: 8.0),
                    child: IntrinsicWidth(
                      child: Column(
                        children: buildTableRowIn.toList(),
                      ),
                    ),
                  ),
                );
              }
            }
            dataTable.refresh((listener) => null);
            loading.refresh((listener) => listener.value = false);
          });
        },
      ),
    );
  }

  static Future<List<SelectData>> getListRelation() async {
    final d = await DB.table(currentForeignKey!.referenceTable).get();
    final List<SelectData> data = [];
    for (var i in d) {
      String? selectedTitle;
      i.forEach((key, value) {
        if (key != currentForeignKey!.referenceColumn) {
          selectedTitle ??= key;
        }
      });
      data.add(
        SelectData(
          id: i[currentForeignKey!.referenceColumn].toString(),
          title: i[selectedTitle].toString(),
        ),
      );
    }
    return data;
  }

  static showAddModal(context) async {
    List<MaterialXFormController> controller = [];
    List<Widget> buildWidget = [];
    List<SelectData> dataSelect = await getListRelation();
    SelectData? dataForeignKey;

    for (final ColumnDatabase i in globalData?.column ?? []) {
      final cont = MaterialXFormController(
        isRequired: i.primaryKey && i.autoIncrement ? false : !i.isNull,
      );
      controller.add(cont);

      buildWidget.add(
        Padding(
          padding: const EdgeInsets.only(bottom: 12),
          child: MaterialXForm(
            onTap: () {
              if (currentForeignKey != null) {
                if (currentForeignKey!.baseColumn == i.name) {
                  Select.single(
                    title: i.name,
                    context: context,
                    data: dataSelect,
                    selectedId: dataForeignKey?.id,
                  ).then((value) {
                    if (value != null) {
                      dataForeignKey = value;
                      cont.controller?.text = value.id ?? '';
                    }
                  });
                }
              }
            },
            title: i.name,
            hintText: i.primaryKey && i.autoIncrement
                ? 'Auto Incement'
                : i.isNull
                    ? '(Optional)'
                    : '(Required)',
            controller: cont,
            isEnabled: !(currentForeignKey != null && currentForeignKey?.baseColumn == i.name) && !(i.primaryKey && i.autoIncrement),
            isNumber: !(i.typeData == DataType.text),
          ),
        ),
      );
    }

    showModalBottomSheet(
        context: context,
        backgroundColor: Colors.transparent,
        isScrollControlled: true,
        builder: (context) {
          return bottom(
            context: context,
            maxHeight: 0.9,
            child: StatefulBuilder(builder: (context, s) {
              return Column(
                children: [
                  Column(
                    children: buildWidget.toList(),
                  ),
                  MaterialXButton(
                    onTap: () {
                      final error = controller.where((element) => element.controller!.text == '' && element.isRequired);
                      if (error.isNotEmpty) {
                        error.map((e) => e.status = FormStatus.error);
                        s(() {});
                        return;
                      } else {
                        final Map<String, String> map = {};
                        for (int i = 0; i < (globalData?.column ?? []).length; i++) {
                          final ColumnDatabase data = globalData!.column[i];
                          if (controller[i].controller?.text != '') {
                            map.addAll({
                              data.name: controller[i].controller?.text ?? '',
                            });
                          }
                        }
                        if (_dataMerge != null) {
                          _dataMerge!.table(globalData!.tableName).listData([map]).insert().then((value) {
                                getTableRow();
                              });
                        } else {
                          DB.table(globalData!.tableName).listData([map]).insert().then((value) {
                                getTableRow();
                              });
                        }
                        Navigator.pop(context);
                      }
                    },
                    title: 'Add',
                  )
                ],
              );
            }),
          );
        }).then(
      (value) => Future.delayed(
        const Duration(milliseconds: 800),
        () {
          for (var i in controller) {
            i.controller?.dispose();
          }
        },
      ),
    );
  }

  static view({isFirst = false, DBMerge? dbMerge, BuildContext? context}) async {
    if (isFirst) {
      dataTable = Fresh([]);
      loading = Fresh(true);
      menuActive = Fresh(0);
    }
    if (dbMerge != null) {
      _dataMerge = dbMerge;
      _buildData(await _dataMerge!.table('sqlite_master').orderBy(['name ASC']).get());
      _buildTable(await _dataMerge!.table('_sql_query_tables').get());
    } else {
      _buildData(await DB.table('sqlite_master').orderBy(['name ASC']).get());
      _buildTable(await DB.table('_sql_query_tables').get());
    }
    if (isFirst && context != null) {
      QueryController.init(context);
      Navigator.push(context, MaterialPageRoute(builder: (b) => const SQLViewer())).then((value) => dispose());
    }
  }

  static delete(id) async {
    if (_dataMerge != null) {
      // _buildTable(await _dataMerge!.table('_sql_query_tables').get());
    } else {
      DB.table(globalData!.tableName).where(globalData!.column.where((element) => element.primaryKey).first.name, '=', id.toString()).delete().then((value) => getTableRow());
    }
  }

  static refresh() async {
    selectedTable = null;
    await view(dbMerge: _dataMerge);
  }

  static _buildTable(data) {
    listTableDatabase = [];
    for (var i in data) {
      final configParse = i['config'].toString().split('|');
      if (listTableDatabase.where((element) => element.tableName == i['name_table']).isNotEmpty) {
        listTableDatabase.where((element) => element.tableName == i['name_table']).first.column.add(
              ColumnDatabase(
                name: i['name_column'],
                typeData: ColumnDatabase.typeDataParse(configParse[0]),
                isNull: configParse[1] == 'true',
                defaultValue: configParse[2] == 'null' ? null : configParse[2],
                autoIncrement: i['is_ai'] == 1,
                primaryKey: i['is_primary'] == 1,
              ),
            );
      } else {
        listTableDatabase.add(TableDatabase(
          column: [
            ColumnDatabase(
              name: i['name_column'],
              typeData: ColumnDatabase.typeDataParse(configParse[0]),
              isNull: configParse[1] == 'true',
              defaultValue: configParse[2] == 'null' ? null : configParse[2],
              autoIncrement: i['is_ai'] == 1,
              primaryKey: i['is_primary'] == 1,
            ),
          ],
          tableName: i['name_table'],
        ));
      }
    }
  }

  static _buildData(List data) {
    dataTable.value.clear();
    dataTable.refresh((listener) => null);
    for (var i in data.where((element) => element['tbl_name'][0] != '_').toList()) {
      dataTable.value.add(SQLMasterModel.build(i));
    }
    dataTable.refresh((listener) => null);
  }

  static dispose() {
    dataTable.value.clear();
    dataTable.dispose();
    loading.dispose();
    QueryController.dispose();
  }
}
