import 'dart:async';

import 'package:flutter/cupertino.dart';
import 'package:flutter/services.dart';

class InitControl extends StatefulWidget {
  final Widget? child;
  final bool? doubleClick;
  final bool? safeArea;
  final Duration? delayPop;
  final VoidCallback? onTapScreen;
  final GlobalKey<FormState>? formKey;
  final Function? onBackPressed;

  const InitControl({
    Key? key,
    this.child,
    this.doubleClick,
    this.safeArea,
    this.delayPop,
    this.onTapScreen,
    this.onBackPressed,
    this.formKey,
  }) : super(key: key);

  @override
  State<InitControl> createState() => _InitControl();
}

class _InitControl extends State<InitControl> {
  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        final FocusScopeNode currentScope = FocusScope.of(context);
        if (!currentScope.hasPrimaryFocus && currentScope.hasFocus) {
          FocusManager.instance.primaryFocus!.unfocus();
        }
        SystemChrome.restoreSystemUIOverlays();
        if (widget.onTapScreen != null) {
          widget.onTapScreen!();
        }
      },
      child: Stack(
        children: [
          Form(
            key: widget.formKey,
            child: SafeArea(top: widget.safeArea ?? false, bottom: widget.safeArea ?? false, child: widget.child ?? const SizedBox()),
          ),
        ],
      ),
    );
  }
}

class StackFunction {
  int id;
  Function function;
  Timer? timer;

  StackFunction({required this.function, required this.id});
}

List<StackFunction> idStack = [];

replacedFunction(StackFunction data) {
  if (idStack.where((element) => element.id == data.id).isEmpty) {
    idStack.add(data);
  } else {
    idStack.where((element) => element.id == data.id).first.timer?.cancel();
    idStack.removeWhere((element) => element.id == data.id);
  }

  data.timer = Timer(const Duration(milliseconds: 500), () {
    idStack.removeWhere((element) => element.id == data.id);
    data.function();
  });
  idStack.add(data);
}
