import 'package:flutter/material.dart';
import 'package:flutter_feather_icons/flutter_feather_icons.dart';

import '../../database_model.dart';
import '../controller/sql_viewer_controller.dart';
import '../model/auto_model.dart';

class TableMenuPart extends StatelessWidget {
  const TableMenuPart({super.key});

  @override
  Widget build(BuildContext context) {
    return Fresher(
      listener: SQL.dataTable,
      builder: (v) {
        final getDataColumn = SQL.listTableDatabase.where((element) => element.tableName == SQL.selectedTable?.tableName);
        TableDatabase? data;
        if (getDataColumn.isNotEmpty) {
          data = getDataColumn.first;
        }

        return Padding(
          padding: const EdgeInsets.symmetric(horizontal: 20.0),
          child: Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              Text(
                SQL.selectedTable?.tableName ?? '',
                style: const TextStyle(
                  fontSize: 18,
                ),
              ),
              data == null
                  ? const SizedBox()
                  : Expanded(
                      child: ListView.builder(
                        itemCount: data.column.length,
                        itemBuilder: (context, i) {
                          final d = data!.column[i];
                          return Padding(
                            padding: const EdgeInsets.only(bottom: 12.0),
                            child: Container(
                              padding: const EdgeInsets.symmetric(horizontal: 20, vertical: 12),
                              decoration: BoxDecoration(
                                color: const Color(0xffF8F8F8),
                                borderRadius: BorderRadius.circular(7),
                                border: Border.all(color: Colors.black26, width: 1),
                              ),
                              child: Row(
                                children: [
                                  Expanded(
                                    child: Row(
                                      children: [
                                        Flexible(child: Text(d.name)),
                                        Text(
                                          ' (${d.typeData.toString().replaceAll('DataType.', '')})',
                                          style: const TextStyle(fontWeight: FontWeight.bold),
                                        ),
                                      ],
                                    ),
                                  ),
                                  d.autoIncrement
                                      ? const Padding(
                                          padding: EdgeInsets.only(right: 8.0),
                                          child: Text(
                                            'AI',
                                            style: TextStyle(fontWeight: FontWeight.bold, fontSize: 26),
                                          ),
                                        )
                                      : const SizedBox(),
                                  d.primaryKey ? const Icon(FeatherIcons.key) : const SizedBox(),
                                ],
                              ),
                            ),
                          );
                        },
                      ),
                    ),
            ],
          ),
        );
      },
    );
  }
}
